#ifndef INCLUDED_BNET_PROTOCOL_TYPES
#define INCLUDED_BNET_PROTOCOL_TYPES

#ifdef JUST_NEED_TYPES
# include "common/bn_type.h"
#else
# define JUST_NEED_TYPES
# include "common/bn_type.h"
# undef JUST_NEED_TYPES
#endif

// This File is used specifically for the PLAY GAME Function
// This defines the structures

typedef struct
{
    bn_short type;
    bn_short size;
} t_bnet_header PACKED_ATTR();
/******************************************************/


/******************************************************/
typedef struct
{
    t_bnet_header h;
} t_bnet_generic PACKED_ATTR();

#define CLIENT_FINDANONGAME 0x44ff
typedef struct   
{   
	t_bnet_header h;   
	bn_byte      cancel;   /* 03 if cancel */
    bn_byte      search;   /* 03 if search */
	bn_short     unknown1; /* 00 00 */
    bn_int       gametype;
    bn_int       unknown2; /* 08 00 00 00 */
    bn_int       unknown3; /* Random Shit */
    bn_int       race;  /* Race User will be */
} t_client_findanongame PACKED_ATTR();
//client Sends race/type info :
//FF 44-18 00 00 03 00 00 00 00 00 0F 00 00 00 08 A6 DD-34 02 20 00 00 00 
#define CLIENT_FINDANONGAME_CANCEL     0x03
#define CLIENT_FINDANONGAME_SEARCH     0x03
/* ADDED BY UNDYING SOULZZ 4/12/02 */
#define CLIENT_FINDANONGAME_PROFILE    0x04

#define CLIENT_FINDANONGAME_UNKNOWN1   0x0000
#define CLIENT_FINDANONGAME_GAMETYPE_1 0x03000000 /* 1 on 1 */
#define CLIENT_FINDANONGAME_GAMETYPE_2 0x3F010000 /* 2 on 2 */
#define CLIENT_FINDANONGAME_GAMETYPE_3 0x03020000 /* 3 on 3 */  
// ADDED 4/18/02 - GAME TYPE FOR WC3 1v1 & 2v2 only
#define CLIENT_FINDANONGAME_GAMETYPE_W3_1V1		0x0f000000 // User selected to play a 1v1 
#define CLIENT_FINDANONGAME_GAMETYPE_W3_2V2 	0xff010000 // User selected to play a 2v2

#define CLIENT_FINDANONGAME_UNKNOWN2   0x08000000
#define CLIENT_FINDANONGAME_UNKNOWN3   0x00000000
#define CLIENT_FINDANONGAME_RACE_RAND  0x00000020
#define CLIENT_FINDANONGAME_RACE_HUM   0x00000001
#define CLIENT_FINDANONGAME_RACE_ORC   0x00000002
#define CLIENT_FINDANONGAME_RACE_UND   0x00000008 // not 3? 8? durr 
#define CLIENT_FINDANONGAME_RACE_NE    0x00000004

#define SERVER_PLAYGAME_ACK    0x44ff
typedef struct
{
	t_bnet_header h;
	bn_byte   playgameack1;
	bn_int    playgameack2;
} t_server_playgame_ack PACKED_ATTR();
#define SERVER_PLAYGAME_ACK1  0x00
#define SERVER_PLAYGAME_ACK2  0x00000000


#define SERVER_FINDANONGAME 0x44ff
typedef struct
{
    t_bnet_header h;
    bn_byte       cancel; /* 03 */
} t_server_findanongame_cancel PACKED_ATTR();

#define SERVER_FINDANONGAME_CANCEL 0x03
typedef struct
{
    t_bnet_header h;
    bn_int        packettype;
    bn_byte       unknown1;  /* 00 */
} t_server_findanongame PACKED_ATTR();

#define SERVER_FINDANONGAME_PACKETTYPE_SEARCH 0x00000000
#define SERVER_FINDANONGAME_PACKETTYPE_FOUND  0x00000001
#define SERVER_FINDANONGAME_UNKNOWN1          0x00
// UNDYING SOULZZ
#define SERVER_FINDANONGAME_PROFILE           0x04
#define SERVER_FINDANONGAME_PROFILE_UNKNOWN1  0x00
#define SERVER_FINDANONGAME_PROFILE_SOLO      0x534F4C4F
#define SERVER_FINDANONGAME_PROFILE_TEAM	  0x5445414D
#define SERVER_FINDANONGAME_PROFILE_STATTEST1  0x00000000
#define SERVER_FINDANONGAME_PROFILE_STATTEST2  0x00000001
#define SERVER_FINDANONGAME_PROFILE_STATTEST3  0x00000006


#define SERVER_FINDANONGAME_RACE_UND   0x00000002

typedef struct
{
    bn_int        matchserver;
    bn_short      matchport;
    bn_short      unknown2; /* Random Shit */
    bn_short      unknown3; /* 00 00 */
    bn_int        unknown4; /* Random Shit */
    bn_short      unknown5; /* 00 06 */
    /* Map name and path */
} t_server_findanongame_1 PACKED_ATTR();

#define SERVER_FINDANONGAME_UNKNOWN2 0x5357
#define SERVER_FINDANONGAME_UNKNOWN3 0x0000
#define SERVER_FINDANONGAME_UNKNOWN4 0x39FE4534
#define SERVER_FINDANONGAME_UNKNOWN5 0x0006
 
typedef struct
{
    bn_int        unknown6; /* FF FF FF FF */
    bn_int        unknown7; /* 42 45 54 41 */
    bn_int        unknown8; /* 00 00 02 04 - 00 00 00 02 */
    bn_short      unknown9; /* 02 01 */
} t_server_findanongame_2 PACKED_ATTR();

#define SERVER_FINDANONGAME_UNKNOWN6 0xFFFFFFFF
#define SERVER_FINDANONGAME_UNKNOWN7 0x42455441
#define SERVER_FINDANONGAME_UNKNOWN8 0x00000002
#define SERVER_FINDANONGAME_UNKNOWN9 0x0201